#include "init_D3D.h"


HRESULT InitD3D(HWND hWnd, unsigned int largeur, unsigned int hauteur, LPDIRECT3D9 *_obj_Direct3D, LPDIRECT3DDEVICE9 *_obj_Direct3DDevice) {

	// Cration d l'objet Direct3D
	if( NULL == ( *_obj_Direct3D = Direct3DCreate9( D3D_SDK_VERSION ) ) )
		return E_FAIL;

	// rcupration du mode d'affichage
	D3DDISPLAYMODE d3ddm;
	if( FAILED((*_obj_Direct3D)->GetAdapterDisplayMode( D3DADAPTER_DEFAULT, &d3ddm)))
		return E_FAIL;

	// paramtres

	D3DPRESENT_PARAMETERS d3dpp;
	ZeroMemory( &d3dpp, sizeof(d3dpp) );
	d3dpp.Windowed = TRUE;
	d3dpp.SwapEffect = D3DSWAPEFFECT_DISCARD;
	d3dpp.BackBufferWidth = largeur;
	d3dpp.BackBufferHeight = hauteur;
	d3dpp.BackBufferFormat = d3ddm.Format;
	d3dpp.BackBufferCount = 1;
	d3dpp.EnableAutoDepthStencil = TRUE;
	d3dpp.AutoDepthStencilFormat = D3DFMT_D16;

	// essai en 32 bits

	D3DFORMAT formatDePixel = D3DFMT_A8R8G8B8;
	d3dpp.BackBufferFormat = formatDePixel;

	if( FAILED( (*_obj_Direct3D)->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
	D3DCREATE_SOFTWARE_VERTEXPROCESSING,
	&d3dpp, _obj_Direct3DDevice ) ) )
	{

		// essai en 24 bits

		D3DFORMAT formatDePixel = D3DFMT_R8G8B8;
		d3dpp.BackBufferFormat = formatDePixel;

		if( FAILED( (*_obj_Direct3D)->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
		D3DCREATE_SOFTWARE_VERTEXPROCESSING,
		&d3dpp, _obj_Direct3DDevice ) ) )
		{

			// essai en 16 bits

			D3DFORMAT formatDePixel = D3DFMT_R5G6B5;
			d3dpp.BackBufferFormat = formatDePixel;

			if( FAILED( (*_obj_Direct3D)->CreateDevice( D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hWnd,
			D3DCREATE_SOFTWARE_VERTEXPROCESSING,
			&d3dpp, _obj_Direct3DDevice ) ) )
			{
				return E_FAIL;

			}

		}

	}

	// paramtr en zbuffer
	(*_obj_Direct3DDevice)->SetRenderState( D3DRS_ZENABLE, TRUE );

	return S_OK;
}
